/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 16/11/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Range;
import com.portofolio.entity.vo.RangeId;

@Lazy
@Repository
public interface RangeDao extends CrudRepository<Range, RangeId> {

	@Cacheable("RangeDaofindOneBy")
	Range findOneByIdKodeAndIdKdProfileAndKdDepartemen(Integer kode, Integer kdProfile, String KdDepartemen);

	@Query(QListAll + " and model.namaRange like %:namaRange% and model.kdJenisRange is null  ")
	@Cacheable("RangeDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaRange") String namaRange,
			Pageable page, @Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll + " and model.namaRange like %:namaRange% and model.kdJenisRange=:kdJenisRange ")
	@Cacheable("RangeDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaRange") String namaRange,
			Pageable page, @Param("kdDepartemen") String kdDepartemen, @Param("kdJenisRange") Integer kdJenisRange);

	@Query(QListAll + " and model.id.kode =:kode")
	@Cacheable("RangeDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode,
			@Param("kdDepartemen") String kdDepartemen);

	String QListAll = "select new map(model.id.kdRange as kdRange,model.id.kdProfile as kdProfile " + ", model.namaRange as namaRange "
			+ ", model.rangeMin as rangeMin " + ", model.rangeMax as rangeMax "
			+ ", model.kdTypeDataObjek as kdTypeDataObjek " + ", typeDataObjek.namaTypeDataObjek as namaTypeDataObjek "
			+ ", model.noUrut as noUrut " + ", model.kdJenisRange as kdJenisRange "
			+ ", jenisRange.namaJenisRange as namaJenisRange " + ", model.kdSatuanStandar as kdSatuanStandar "
			+ ", satuanStandar.namaSatuanStandar as namaSatuanStandar " + ", model.factorRate as factorRate "
			+ ", model.operatorFactorRate as operatorFactorRate " + ", model.kodeExternal as kodeExternal "
			+ ", model.namaExternal as namaExternal " + ", model.kdDepartemen as kdDepartemen, model.reportDisplay as reportDisplay "
			+ ", model.statusEnabled as statusEnabled " + ", model.noRec as noRec "
			+ ", departemen.namaDepartemen as namaDepartemen, model.version as version )"
			+ " from Range model left join model.id id " + " left join model.jenisRange jenisRange "
			+ " left join model.typeDataObjek typeDataObjek " + " left join model.satuanStandar satuanStandar "
			+ " left join model.departemen departemen "
			+ " left join model.profile profile where profile.kode =:kdProfile and model.kdDepartemen = :kdDepartemen ";

	Range findOneByIdKodeAndIdKdProfile(Integer kdRangeMasaKerjaPegawai, Integer kdProfile);

	@Query("select new Map(id.kode as kdRange, namaRange as namaRange) from Range where  kdJenisRange=:kdJenisRange and id.kdProfile=:kdProfile and statusEnabled=true")
	List<Map<String, Object>> getRangeByJenis(@Param("kdProfile") Integer kdProfile,
			@Param("kdJenisRange") Integer kdJenisRange);

	@Query(qFindAllRangeWaktuPinjaman)
	List<Map<String,Object>> findAllRangeWaktuPinjaman(@Param("kdProfile") Integer kdProfile, @Param("kdJenisRange") Integer kdJenisRange);

	
	String qFindAllRangeWaktuPinjaman = "select new map(model.id as id, model.namaRange as namaRange) "
			+ " from Range model "
			+ " where model.id.kdProfile=:kdProfile "
			+ " and model.kdJenisRange=:kdJenisRange";
	

	@Query("select new map(model.id.kode as kode,model.kdJenisRange as kdJenisRange ,model.namaRange as namaRange) from Range model  where model.id.kdProfile=:kdProfile and model.kdJenisRange=:KdJenisRange and statusEnabled=true  ")
	List<Map<String,Object>> findRangeByKdProfileAndKdRangeHead(@Param("kdProfile")Integer kdProfile,@Param("KdJenisRange") Integer KdJenisRange );
	//@Query(QListAllKeterlambatan + " and model.id.kode =:kode")
	
	@Query(QListAllKeterlambatan + " and model.statusEnabled=True and model.kdJenisRange =:kode")
	@Cacheable("RangeDaoFindByKode")
	List<Map<String, Object>> findByKodeKeterlambatan(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode);
	
	@Query(" select min(model.id.kode) from Range model where model.id.kdProfile=:kdProfile ")
	Integer getDefaultRange(@Param("kdProfile") Integer kdProfile);

	String QListAllKeterlambatan = "select new map(model.id.kdRange as kdRange,model.id.kdProfile as kdProfile " + ", model.namaRange as namaRange "
			+ ", departemen.namaDepartemen as namaDepartemen, model.version as version )"
			+ " from Range model left join model.id id " + " left join model.jenisRange jenisRange "
			+ " left join model.typeDataObjek typeDataObjek " + " left join model.satuanStandar satuanStandar "
			+ " left join model.departemen departemen "
			+ " left join model.profile profile where profile.kode =:kdProfile  ";
	
	
	String qFindAllRange = "select new map(model.id as id, model.namaRange as namaRange) "
			+ " from Range model "
			+ " where model.id.kdProfile=:kdProfile ";
			
	@Query(qFindAllRange + " and model.statusEnabled=True ") 
	List<Map<String, Object>> findAllData(@Param("kdProfile") Integer kdProfile);
}
